Package org.optaplanner.core.impl.localsearch.decider.forager.finalist

## Class StrategicOscillationByLevelFinalistPodium<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter<Solution_>
  - - org.optaplanner.core.impl.localsearch.event.LocalSearchPhaseLifecycleListenerAdapter<Solution_>
    - - org.optaplanner.core.impl.localsearch.decider.forager.finalist.AbstractFinalistPodium<Solution_>
      - - org.optaplanner.core.impl.localsearch.decider.forager.finalist.StrategicOscillationByLevelFinalistPodium<Solution_>

- All Implemented Interfaces:
    `EventListener`, `FinalistPodium<Solution_>`, `LocalSearchPhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`

      public class StrategicOscillationByLevelFinalistPodium<Solution_>
      extends AbstractFinalistPodium<Solution_>

  Strategic oscillation, works well with Tabu search.
  See Also:
    `FinalistPodium`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected boolean` | `finalistImprovesUponReference` |
    `protected Number[]` | `finalistLevelNumbers` |
    `protected Score` | `finalistScore` |
    `protected boolean` | `referenceBestScoreInsteadOfLastStepScore` |
    `protected Number[]` | `referenceLevelNumbers` |
    `protected Score` | `referenceScore` |

    - ### Fields inherited from class org.optaplanner.core.impl.localsearch.decider.forager.finalist.AbstractFinalistPodium

      `FINALIST_LIST_MAX_SIZE, finalistIsAccepted, finalistList, logger`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `StrategicOscillationByLevelFinalistPodium​(boolean referenceBestScoreInsteadOfLastStepScore)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addMove​(LocalSearchMoveScope<Solution_> moveScope)` | See `LocalSearchForager.addMove(LocalSearchMoveScope)`.
    `void` | `phaseEnded​(LocalSearchPhaseScope<Solution_> phaseScope)` |
    `void` | `stepStarted​(LocalSearchStepScope<Solution_> stepScope)` |

    - ### Methods inherited from class org.optaplanner.core.impl.localsearch.decider.forager.finalist.AbstractFinalistPodium

      `addFinalist, clearAndAddFinalist, getFinalistList`

    - ### Methods inherited from class org.optaplanner.core.impl.localsearch.event.LocalSearchPhaseLifecycleListenerAdapter

      `phaseStarted, stepEnded`

    - ### Methods inherited from class org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter

      `solvingEnded, solvingStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.localsearch.event.LocalSearchPhaseLifecycleListener

      `phaseStarted, stepEnded`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener

      `solvingEnded, solvingStarted`

- - ### Field Detail

    - #### referenceBestScoreInsteadOfLastStepScore

          protected final boolean referenceBestScoreInsteadOfLastStepScore

    - #### referenceScore

          protected Score referenceScore

    - #### referenceLevelNumbers

          protected Number[] referenceLevelNumbers

    - #### finalistScore

          protected Score finalistScore

    - #### finalistLevelNumbers

          protected Number[] finalistLevelNumbers

    - #### finalistImprovesUponReference

          protected boolean finalistImprovesUponReference

  - ### Constructor Detail

    - #### StrategicOscillationByLevelFinalistPodium

          public StrategicOscillationByLevelFinalistPodium​(boolean referenceBestScoreInsteadOfLastStepScore)

  - ### Method Detail

    - #### stepStarted

          public void stepStarted​(LocalSearchStepScope<Solution_> stepScope)

      Specified by:
        `stepStarted` in interface `LocalSearchPhaseLifecycleListener<Solution_>`
      Overrides:
        `stepStarted` in class `AbstractFinalistPodium<Solution_>`

    - #### addMove

          public void addMove​(LocalSearchMoveScope<Solution_> moveScope)

      Description copied from interface: `FinalistPodium`
      See `LocalSearchForager.addMove(LocalSearchMoveScope)`.
      Parameters:
        `moveScope` - never null

    - #### phaseEnded

          public void phaseEnded​(LocalSearchPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseEnded` in interface `LocalSearchPhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseEnded` in class `AbstractFinalistPodium<Solution_>`